
//     SIMULATION FERME #8F-1
//     Hubert SPERI
//     27/12/2021
//     Modifié : 24/01/2022
//                -- ajout des codes «21», «22» et «23» pour changer le volume sonore ;
//                -- suppression de 3 lignes de code dans la fonction «void Interception_du_code_IR_pour_interrompre_le_programme()» ;
//                -- mise en commentaires de certaines fonctions d'impression.
//     Modifié : 03/02/2022
//                -- ajout du code «2» + «POWER» pour la mise en route et l'arrêt ;
//                -- utilisation de «loop()» pour réinitialiser le programme.
//     Modifié : 04/02/2022
//                -- mise à jour de commentaires. 
//_________________________

//ADUINO UNO ou NANO
//DFPlayer MINI : lecteur de fichier MP3
//_________________________

// CODE à 2 CHIFFRES POUR L'APPLICATION «FERME» :
// -- 2 + POWER : code de mise en route et d'arrêt ;
// -- 21 : volume sonore = 23 ;
// -- 22 : volume sonore = 25 ;
// -- 23 : volume sonore = 27 ;

//_________________________

//SEQUENCES SONORES
//
//Les séquences sonores que j'ai utilisées durent environ 9 minutes.
//Elles ont été composées sur AUDACITY, à partir d'enregistrements de sons réels.

//_________________________

//ENTREES - SORTIES

//-- LED_four_a_pain : sortie «6» ;
//-- LED_interieure  : sortie «9» ;

//-- capteur infrarouge : entrée «2» ;

//-- Rx de l'ARDUINO : broche «11», reliée à la broche «Tx» du DFPlayer ;
//-- Tx de l'ARDUINO : broche «12», reliée à la broche «Rx» du DFPlayer ;

//Note : dans ce programme, la liason «Rx ARDUINO» vers «Tx DFPlayer» n'est pas utile.

//On n'utilise pas la broche «BUSY» du DFPlayer.

//___________________________________________________________________________



#include <IRremote.h>
#include <SoftwareSerial.h>
#include <DFRobotDFPlayerMini.h>

SoftwareSerial mySoftwareSerial(11,12); // la broche «11» de l'ARDUINO est utilisée comme «Rx» pour communiquer avec la broche «Tx» du DFPlayer.
                                        // la broche «12» de l'ARDUINO est utilisée comme «Tx» pour communiquer avec la broche «Rx» du DFPlayer.
                                        // Note : la liaison «Rx ARDUINO» --> «Tx DFPlayer» n'est pas utilisée dans ce programme.
                                        
DFRobotDFPlayerMini myDFPlayer;

int IRpin = 2;                          // entrée du capteur IR
IRrecv irrecv(IRpin);
decode_results results;

int LED_interieure = 9 ;                // jaune
int LED_four_a_pain = 6 ;               // rouge

int Numero_du_son ;
int Nombre_de_sons ;
int Volume ;

//const int  Touche_9 = 272 ; 
//const int  Touche_8 = 3600 ; 
//const int  Touche_7 = 1552 ;
//const int  Touche_6 = 2576 ;
//const int  Touche_5 = 528 ;
//const int  Touche_4 = 3088 ;
        const int  Touche_3 = 1040 ;
        const int  Touche_2 = 2064 ;
        const int  Touche_1 = 16 ;
//const int  Touche_0 = 2320 ;
//const int  Touche_Up = 1904 ;
//const int  Touche_Down = 3952 ;
//const int  Touche_Left = 2800 ;
//const int  Touche_Right = 752 ;
//const int  Touche_VolUp = 1168 ;
//const int  Touche_VolDown = 3216 ;
//const int  Touche_CH_Up = 144 ;
//const int  Touche_CH_Down = 2192 ;
const int  Touche_POWER = 2704 ;
//const int  Touche_Menu =112 ;
  
int Code_a_2_chiffres ;
int OK ;                   // Utilisé comme quittance quand le code à 2 chiffres reçu est celui qui est attendu.


int numero ;               // variable pour choisir un son différent à chaque redémarrage du programme.
                           // Ce n'est pas un nombre aléatoire. Juste différent à chaque fois.
                           // Ce nombre dépend aussi du nombre de faux codes de démarrage (volontaires ou non).

bool flag ;                // flag = true  ⇒ les séquences s'enchaînent normalement.
                           // flag = false ⇒ les séquences sont ignorées et le programme se repositionne à son début.

int ON ;
int OFF ;
  
long Temps_IN ;         
long Temps_OUT ;

long Temps_initial ;
long Temps_final ;

long Duree_allumage_du_four_a_pain ;








void Interception_du_code_IR_SONY_pour_le_demarrage() 
  {
  // Code 20 (Touche_2 ; Touche_POWER) : code de mise en route ;

  Code_a_2_chiffres = !OK ;
  irrecv.resume(); 
    
  // Saisie et traitement du premier chiffre. 
  while (!(irrecv.decode(&results)))               // Attend indéfiniment (sans rien faire) la réception du premier code.
  { 
      // boucle d'attente de réception d'un code.
  }
  numero = numero + 1 ;                            // A chaque réception d'un code, le numero de la séquence sonore est incrémenté
  Numero_du_son = numero % Nombre_de_sons + 1 ;    // Si la carte «T» contient 4 séquences sonores, «numero» doit être transformé en un nombre
                                                   // compris entre 1 et 4 inclus.
      Serial.print("Premier chiffre = ");
      Serial.println(results.value);               //Affiche le code reçu.
      
  if (results.value != Touche_2)  {loop() ; }
  else                                              // Si le code est celui de la touche «2», alors on attend le 2e code.
      {
      results.value = 999 ;
      delay(300) ;
      irrecv.resume();                              // Receive the next value


 // Saisie et traitement du deuxième chiffre.                
      Temps_IN = millis() / 1000 ;
      while (!(irrecv.decode(&results)))            // Attend indéfiniment (sans rien faire) la réception du 2e code.
           {
           // boucle d'attente
           delay(5) ;
           Temps_OUT = millis() / 1000 ;
           if ((Temps_OUT - Temps_IN) > 2)          // Si aucun 2e code détecté avant 2 secondes, on quitte la boucle «while»
               {
               results.value = 999 ;                // ... en imposant un code non valide.
               loop() ; 
               } 
            }
        Serial.print("Deuxième chiffre ⇒ ");
        Serial.println(results.value); 
        if (results.value == Touche_POWER)          // Si le code est celui de la touche «2», alors «Code_a_2_chiffres» = OK
          {
          Code_a_2_chiffres = OK ;     
          }         
    }
    delay(1000) ;                                   // Delai avant une 2e tentative.
    
}   







void Interception_du_code_IR_pour_interrompre_le_programme() 
  {
  // Codes à 2 chiffres pour cette application :
  // -- (Touche_2 ; Touche_POWER) :code d'arrêt ;  
  // -- 21 (Touche_2 ; Touche_1) : code pour volume sonore par défaut ;
  // -- 22 (Touche_2 ; Touche_2) : code pour volume sonore plus fort ;
  // -- 23 (Touche_2 ; Touche_3) : code pour volume sonore encore plus fort ;
 
  Code_a_2_chiffres = !OK ;
  flag = true ;
  results.value = 999 ;  
  irrecv.resume(); 
  delay(200) ;  
  
 // Saisie et traitement du premier chiffre. 
    if (irrecv.decode(&results)) 
      {
      Serial.print("Premier chiffre ⇒ ");
      Serial.println(results.value);
      delay(400) ;  
      irrecv.resume();   // Receive the next value
      }

    if (results.value == Touche_2) 
        {        
        Serial.println(results.value) ;
        results.value = 999 ;  

        
 // Saisie et traitement du deuxième chiffre. 
        Temps_IN = millis() ;
        while (!(irrecv.decode(&results)))             // Attend indéfiniment (sans rien faire) la réception du 2e code.
              {
              // boucle d'attente
              delay(10) ;
              Temps_OUT = millis() ;
              if ((Temps_OUT - Temps_IN) >= 1200)       // Si aucun 2e code détecté avant 1200 millisecondes, on quitte la boucle «while»
                  {
                  Serial.println("Temps d'attente dépassé") ;
                  results.value = 999 ;                  // ... en imposant un code non valide.
                  break ;
                  } 
              }
      if (results.value == Touche_POWER)
          {
          Serial.print("Deuxième chiffre ⇒ ");
          Serial.println(results.value);
          flag = false ;
          delay(1000) ;
          results.value = 999 ;
          return(0) ;
          }
                    
      if (results.value == Touche_1)  // Code pour mettre le volume à 23 ;
          {
          delay(100) ;
          myDFPlayer.volume(23);           return(0) ;
          }
      if (results.value == Touche_2)  // Code pour mettre le volume à 25 ;
          {
          delay(100) ;
          myDFPlayer.volume(25);           return(0) ;
          } 
      if (results.value == Touche_3)  // Code pour mettre le volume à 27 ;
          {
          delay(100) ;
          myDFPlayer.volume(27);           return(0) ;
          }               
     }
     return ;
}








int Flame_four_a_pain(int Duree_allumage_du_four_a_pain) 
  {
  Serial.println("Flame du four en route") ;
  Temps_IN = millis() / 1000 ;
  
  while ((Temps_OUT - Temps_IN) <= Duree_allumage_du_four_a_pain)
      {
      analogWrite(LED_four_a_pain, (random(10 , 16) * 10));       // LED rouge 
      delay((random(1, 4) * 24));
      
      Interception_du_code_IR_pour_interrompre_le_programme() ;
      if (flag == false) 
         {
         analogWrite(LED_four_a_pain, 0) ; 
         Eclairage_interieur(OFF) ; 
         loop() ; 
         }      
     
      Temps_OUT = millis() / 1000 ;
      }
  }








int Extinction_four_a_pain(int coef) 
  {  
  Serial.println("Extinction progressive du four") ;

  for (int Luminosite = 160 ; Luminosite >= 0 ; Luminosite--)
      {
      analogWrite(LED_four_a_pain, Luminosite); // LED rouge
      delay(30 * coef) ;
      Interception_du_code_IR_pour_interrompre_le_programme() ;
      if (flag == false) 
         {
         analogWrite(LED_four_a_pain, 0) ; 
         Eclairage_interieur(OFF) ; 
         loop() ; 
         } 
      }
  }








int  Allumage_four_a_pain(int coef) 
  { 
  Serial.println("Allumage progressif du four") ;

  for (int Luminosite = 0 ; Luminosite <= 160 ; Luminosite++)
      {
      analogWrite(LED_four_a_pain, Luminosite); // LED rouge
      delay(5 * coef) ;
      Interception_du_code_IR_pour_interrompre_le_programme() ;
      if (flag == false) 
         {
         analogWrite(LED_four_a_pain, 0) ; 
         Eclairage_interieur(OFF) ; 
         loop() ; }
         }
  }








int Eclairage_interieur(int state)
   {
   Serial.println("Allumage/extinction éclairage intérieur") ;

   analogWrite (LED_interieure, state) ;  // niveau d'éclairement réglé par la valeur de la variable «ON».
   }








int delay_seconds(long nb_seconds)
   {       
   for(int i = 1 ; i <= nb_seconds ; i++)
      {
      Interception_du_code_IR_pour_interrompre_le_programme() ;
      if (flag == false) {Eclairage_interieur(OFF) ; loop() ; }
      delay (1000) ;     
      }   
    }






/*
void Controle()                   // Impressions de contrôle. NE PAS SUPPRIMER.
  {
  Serial.println() ;
  Serial.print("Numero du son = ") ;
  Serial.println(Numero_du_son) ;
  digitalWrite(13, HIGH) ;
  delay(1000) ;
  digitalWrite(13, LOW) ;
  irrecv.resume();   // Receive the next value
  }

*/







void setup() 
  {

  irrecv.enableIRIn();

  pinMode(6, OUTPUT);                     // LED rouge ...
  pinMode(9, OUTPUT);                     // et LED jaune du foyer

  ON = 255 ;                              // pou régler le niveau d'éclairement de la LED intérieure.
  OFF = 0 ;


  mySoftwareSerial.begin(9600);           // pour communiquer avec le DFPlayer
  myDFPlayer.begin(mySoftwareSerial);
  myDFPlayer.volume(0);
 

  Serial.begin(9600);                     // Pour communiquer avec le moniteur
  pinMode(13, OUTPUT);                    // LED de contrôle de la réception d'un code.

  Nombre_de_sons = myDFPlayer.readFileCounts() ;   // C'est le nombre de séquences sonores enregistrées sur la carte «T».

  //----Set different EQ----
  //  myDFPlayer.EQ(DFPLAYER_EQ_NORMAL);
  //  myDFPlayer.EQ(DFPLAYER_EQ_POP);
  //  myDFPlayer.EQ(DFPLAYER_EQ_ROCK);
             myDFPlayer.EQ(DFPLAYER_EQ_JAZZ);      //Pour renforcer un peu les aigus quand le HP est masqué dans le décor.
  //  myDFPlayer.EQ(DFPLAYER_EQ_CLASSIC);
  //  myDFPlayer.EQ(DFPLAYER_EQ_BASS);
  }










void loop() 
  {
  results.value = 0 ;             // Mise à zero du code reçu.
  flag = true ;                   // flag = false : lorsque le code d'arrêt est reçu ⇒ le déroulement est écourté.
  OK = true ;                     // ... si le code à 2 chiffres reçu est le code attendu.
  Volume = 23 ;                   // volume sonore par défaut (modifier en fonction du HP).
  myDFPlayer.volume(Volume);   
   
  //  Temps_IN = millis() / 1000 ;              
 
    Serial.println("-------------------------") ;
    Serial.println("Attente du code démarrage") ; 
   
  Interception_du_code_IR_SONY_pour_le_demarrage() ;
  
  if (Code_a_2_chiffres == OK) 
    { 
    Temps_initial = millis() / 1000 ;
    int MAP_vs_REEL = 10 ;                          // Ce coefficient vaut «1» en phase de mise au point (MAP) et 10 à 50 en utilisation réelle.
      
    Serial.println("Départ séquence sonore") ; 
    myDFPlayer.play(Numero_du_son);                 // «Numero_du_son» est calculé dans la fonction «Interception_du_code_IR_SONY_pour_le_demarrage()»
    delay_seconds(5 * MAP_vs_REEL) ;                // Le son démarre seul pendant (5 x MAP_vs_REEL) secondes.
         Temps_final = millis() / 1000 ;
         Serial.print("    ⇒ Temps final attente = ") ;
         Serial.print(Temps_final - Temps_initial) ;
         Serial.println(" secondes") ;
         Serial.println() ;
    Allumage_four_a_pain(MAP_vs_REEL) ;
         Temps_final = millis() / 1000 ;
         Serial.print("    ⇒ Temps final allumage progressif du four = ") ;
         Serial.print(Temps_final - Temps_initial) ;
         Serial.println(" secondes") ;
         Serial.println() ;
    Flame_four_a_pain((20 * MAP_vs_REEL)) ;          // Temps exprimé en secondes.
         Temps_final = millis() / 1000 ;
         Serial.print("    ⇒ Temps final flame four = ") ;
         Serial.print(Temps_final - Temps_initial) ;
         Serial.println(" secondes") ;
         Serial.println() ;
    Eclairage_interieur(ON) ;                      // La valeur de «ON» est réglée dans SETUP entre 0 et 255 pour régler l'intensité de l'éclairage intérieur.
    Flame_four_a_pain(2 * MAP_vs_REEL) ;           // On RE-enclenche le four à pain... sinon l'instruction précédente, «Eclairage_interieur», stoppe le four à pain.
         Temps_final = millis() / 1000 ;
         Serial.print("    ⇒ Temps final flame four = ") ;
         Serial.print(Temps_final - Temps_initial) ;
         Serial.println(" secondes") ;
         Serial.println() ;
    Extinction_four_a_pain(MAP_vs_REEL) ;           // Phase d'extinction progressive du four.
         Temps_final = millis() / 1000 ;
         Serial.print("    ⇒ Temps final extinction four = ") ;
         Serial.print(Temps_final - Temps_initial) ;
         Serial.println(" secondes") ;
         Serial.println() ;
    delay_seconds(5 * MAP_vs_REEL) ;                 // Le four est arrêté, mais l'éclairage intérieur est toujours «ON».
    Eclairage_interieur(OFF) ;
         Temps_final = millis() / 1000 ;
         Serial.print("    ⇒ Temps final éclairage intérieur = ") ;
         Serial.print(Temps_final - Temps_initial) ;
         Serial.println(" secondes") ;
         Serial.println() ;
    delay_seconds(20 * MAP_vs_REEL) ;                // Cette tempo doit être ajustée pour laisser à la séquence sonore de se terminer naturellement.
    myDFPlayer.stop() ;  
 
    //Temps_final = millis() / 1000 ;
         //Serial.print("    ⇒ Durée séquence = ") ;
         //Serial.print(Temps_final - Temps_initial) ;
         //Serial.println(" secondes") ;
    }
  }
